SystemOrganization addCategory: #'Xenon-Tests'!

Object subclass: #XeFunctionWhenItHasManyReturnTypeScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWhenItHasManyReturnTypeScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #int>
	<returnType: #void>
! !

Object subclass: #XeFunctionWhenReturnTypeIsDefaultScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWhenReturnTypeIsDefaultScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
! !

Object subclass: #XeFunctionWhenReturnTypeIsIntegerScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWhenReturnTypeIsIntegerScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #int>
! !

Object subclass: #XeFunctionWhenReturnTypeIsUnknownScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWhenReturnTypeIsUnknownScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #unknown>
! !

Object subclass: #XeFunctionWithOneArgumentScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWithOneArgumentScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/2/2012 01:57'!
foo: x
	<returnType: #int>
! !

Object subclass: #XeFunctionWithTwoArgumentsScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeFunctionWithTwoArgumentsScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/3/2012 23:36'!
foo: x and: y
	<returnType: #int>
! !

TestCase subclass: #XeTranslateFunctionTest
	instanceVariableNames: 'cg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeTranslateFunctionTest methodsFor: 'running' stamp: 'BernardoContreras 4/3/2012 21:05'!
setUp
	cg := XeCodeGenerator new! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/3/2012 21:13'!
testTranslateFunctionWhenItHasManyReturnTypes
	cg addClass: XeFunctionWhenItHasManyReturnTypeScenario.
	self should: [cg codeString] raise: XeTooManyReturnTypesError
! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/3/2012 21:37'!
testTranslateFunctionWhenReturnTypeIsDefault
	| actual expected |
	cg addClass: XeFunctionWhenReturnTypeIsDefaultScenario.
	actual := cg codeString.
	expected := 'sqInt foo(){
}'.
	self assert: expected equals: actual! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/3/2012 21:43'!
testTranslateFunctionWhenReturnTypeIsInteger
	| actual expected |
	cg addClass: XeFunctionWhenReturnTypeIsIntegerScenario.
	actual := cg codeString.
	expected := 'int foo(){
}'.
	self assert: expected equals: actual! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/3/2012 21:43'!
testTranslateFunctionWhenReturnTypeIsUnknown
	cg addClass: XeFunctionWhenReturnTypeIsUnknownScenario.
	self should: [ cg codeString ] raise: XeTypeNotFoundError! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/3/2012 21:44'!
testTranslateFunctionWithOneArgument
	| actual expected |
	cg addClass: XeFunctionWithOneArgumentScenario.
	actual := cg codeString.
	expected := 'int foo(sqInt x){
}'.
	self assert: expected equals: actual! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 4/3/2012 23:37'!
testTranslateFunctionWithTwoArguments
	| actual expected |
	cg addClass: XeFunctionWithTwoArgumentsScenario.
	actual := cg codeString.
	expected := 'int fooand(sqInt x, sqInt y){
}'.
	self assert: expected equals: actual! !
